<html>
    <head>
        <meta charset='utf-8'>
        <title>Cadastro Simples</title>
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.0/dist/css/bootstrap.min.css">
    </head>
    <body>
        <div class="container">
            <h1>Cadastro Sinples</h1>
            <hr>
            <div>
                <input name='id' type='hidden' />
                <div class="form-group">
                    <label for="Name"></label>
                    <input class='form-control' name='name' placeholder='Digite o nome' />
                </div>
                <button class='btn btn-sucess' save>Salvar</button>
            </div>

            <table class="table" id='clients'>
                <thead>
                    <tr>
                        <th>Nome</th>
                        <th>Ações</th>
                    </tr>
                </thead>
                <tbody id="clientsRows"></tbody>
            </table>

            <div class="row">
                <img src="img/qr-code.png" id="imgLinkPesquisa" alt="QR CODE" width="500" height="500">
        
                <input type="button" style="margin-top:5px" value="Copiar" id="btnCopiarQrCode" onclick="javascript: CopyToClipboard();"/>
            </div>
    
        </div>

    

        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>

        <script>
            const API = 'http://localhost:3000'

            const createButton = (label, type) => {
                return $('<button>').addClass(`btn btn-${type}`).html(label)
            }

            const renderRows = clients => {
                const rows = clients.map(client => {
                    const updateButton = createButton('Atualizar', 'warning')
                    updateButton.click(() => loadClient(client))
                    
                    const removeButton = createButton('Excluir', 'danger')
                    removeButton.click(() => removeClient(client))

                    return $('<tr>')
                        .append($('<td>').append(client.name))
                        .append($('<td>').append(updateButton).append(removeButton))
                })

                $('#clientsRows').html(rows)
            }

            const loadClient = client => {
                $('[name=id]').val(client._id)
                $('[name=name]').val(client.name)
            }

            const removeClient = client => {
                $.ajax({
                    method: 'DELETE',
                    url: `${API}/clients/${client._id}`,
                    success: getClients
                })
            }

            const getClients = () => {
                $.ajax({
                    url: `${API}/clients`,
                    success: clients => {
                        renderRows(clients)
                        $('[name]').val('')
                    }
                })
            }

            const saveClient = () => {
                const _id = $('[name=id]').val()
                const name = $('[name=name]').val()
                $.ajax({
                    method: _id ? 'PUT' : 'POST',
                    url: `${API}/clients/${_id}`,
                    data: _id ? { _id, name} : { name},
                    success: getClients
                })
            }


            function CopyToClipboard() {
            let elementoImg = document.getElementById("imgLinkPesquisa");
            urlImg = elementoImg.currentSrc;
            CopyToImage(urlImg);
            }

            async function CopyToImage(imageURL) {
                const blob = await ImageToBlob(imageURL);
                const item = new ClipboardItem({ "image/png": blob });
                navigator.clipboard.write([item]);
            }

            function ImageToBlob(imageURL) {
                const img = new Image;
                const c = document.createElement("canvas");
                const ctx = c.getContext("2d");
                img.crossOrigin = "";
                img.src = imageURL;
                return new Promise(resolve => {
                    img.onload = function () {
                        c.width = this.naturalWidth;
                        c.height = this.naturalHeight;
                        ctx.drawImage(this, 0, 0);
                        c.toBlob((blob) => {
                            resolve(blob)
                        }, "image/png", 0.75);
                    };
                });
            }


            $(() => {
                getClients()
                $('[save]').click(saveClient)
            })
        </script>
    </body>
</html>